CON
'{ Hybrid Block
  _clkmode = xtal1 + pll16x
  _xinfreq = 6_000_000
  tv_pins = %011_0000
  key_pins = 12
NES_RIGHT  = %00000000_00001000
NES_LEFT   = %00000000_00000100
NES_DOWN   = %00000000_00000010
NES_UP     = %00000000_00000001
NES_START  = %00000000_00100000
NES_SELECT = %00000000_00100000
NES_B      = %00000000_00100000
NES_A      = %00000000_00100000
'}
{ Hydra Block
  _clkmode = xtal2 + pll8x
  _xinfreq = 10_000_000
  tv_pins = %011_0000
  key_pins = 3
NES_RIGHT  = %00000000_00000001
NES_LEFT   = %00000000_00000010
NES_DOWN   = %00000000_00000100
NES_UP     = %00000000_00001000
NES_START  = %00000000_00010000
NES_SELECT = %00000000_00100000
NES_B      = %00000000_01000000
NES_A      = %00000000_10000000
'}
{ ProtoDemo Block
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  tv_pins = %001_0101
  key_pins = 26
NES_RIGHT  = %00000000_00001000
NES_LEFT   = %00000000_00000100
NES_DOWN   = %00000000_00000010
NES_UP     = %00000000_00000001
NES_START  = %00000000_00100000
NES_SELECT = %00000000_00100000
NES_B      = %00000000_00100000
NES_A      = %00000000_00100000
'}

x_tiles = 32
y_tiles = 24
mode    = %0000
my_hx   = 10+((mode&1)<<1)

REX_LIES_IN_WAIT        = 1
HE_IS_HUNTING_FOR_YOU   = 2
FOOTSTEPS_APPROACHING   = 3
RUN_HES_BEHIND_YOU      = 4
RUN_HES_BESIDE_YOU      = 5
REX_HAS_SEEN_YOU        = 6

OBJ
  scr  : "JB_ZX81_TV"
  key  : "comboKeyboard"
  
VAR
  long ioControl[2]

  byte  myscr[768]
  byte  tvscr[768]

  long  txtx
  long  txty
  long  txtcol

  long  joy
  long  ojoy
  
  long  frame
  long  done

  long  redraw
  long  seed

  long  mapx,mapy,mapxd,mapyd,mapxr,mapyr
  long  rexx,rexy,rexxd,rexyd,rexmc,rexac,rexwt,lastsx,lastsy

PUB Start | t, x , y, c

  seed:=$DEADFACE

  tvscrptr:=@tvscr
  scr.start(@tvparams)
  key.start(key_pins)

  t:=25
  printat(string("k"),0,23,0)
  Wait(50)
  printat(string(" "),0,23,0)
  Wait(1)
  repeat y from 0 to 8
    pchars(@loading_texts+y*14,0,23,0,14)
    t:=WaitKey(t)
    pchars(string("              "),0,23,0,14)
    Wait(1)
  
  t:=WaitKey(50)
  
  printat(string("ANYONE THERE?"),10,12,0)
  t:=WaitKey(5*50)
  if t<>1
    printat(string("WELL PRESS SOMETHING THEN."),3,14,0)
    repeat while t<>1
      Wait(1)
      joy:=Read_Gamepad
      if joy & NES_A
        t:=1

  bytefill(@scoretxt,"0",4)
  done:=0  
  repeat
    if done==0
      t:=scrolltext(@roll_up_message)
    else
      t:=scrolltext(@mists_message)      
      
    wait(25)

    reset_positions    

    bytefill(@myscr,0,768)

    done:=0
    repeat while done==0
      ojoy:=joy
      joy:=Read_Gamepad
      wait(1)
      showwalls
      pchars(@scoretext,27,8,0,5)
      pscore(27,9)
      pchars(@rex_texts+(rexac*22),1,23,0,22)

      handle_trex

      if (joy & NES_UP) and ((ojoy & NES_UP)==0)
        if getmap(mapx+mapxd,mapy+mapyd)=="0"
          mapx+=mapxd
          mapy+=mapyd
          if rexac<>REX_LIES_IN_WAIT
            addscore(@add5txt)
          rexwt:=0

'      if (joy & NES_DOWN) and ((ojoy & NES_DOWN)==0)
'        if getmap(mapx-mapxd,mapy-mapyd)=="0"
'          mapx-=mapxd
'          mapy-=mapyd

      if (joy & NES_LEFT) and ((ojoy & NES_LEFT)==0)
        t:=mapxd
        mapxd:=mapyd
        mapyd:=-t
        t:=mapxr
        mapxr:=mapyr
        mapyr:=-t
        rexwt:=0

      if (joy & NES_RIGHT) and ((ojoy & NES_RIGHT)==0)
        t:=mapxd
        mapxd:=-mapyd
        mapyd:=t
        t:=mapxr
        mapxr:=-mapyr
        mapyr:=t
        rexwt:=0

      if getmap(mapx+mapxd,mapy+mapyd)=="3"
        addscore(@add200txt)
        repeat y from 0 to 23
          pchars(@cleared_text[y*7],25,y,0,7)
        pscore(27,7)
        repeat 5*50
          wait(1)
          showwalls
        repeat y from 0 to 23
          bytefill(@myscr[y*32],0,32)
          wait(1) 
        done:=1

      if rexx==mapx and rexy==mapy
        pscore(27,9)
        repeat y from 0 to 23
          bytemove(@myscr+y<<5,@eaten1+y<<5,25)
        wait(25)
        repeat y from 0 to 23
          bytemove(@myscr+y<<5,@eaten2+y<<5,25)
        pscore(0,12)
            
        wait(3*50)
        bytefill(@scoretxt,"0",4)
        done:=1

pub reset_positions | t
    mapx:=0
    mapy:=0
    mapxd:=1
    mapyd:=0
    mapxr:=0
    mapyr:=1

    seed:=(?seed)
    t:=seed&3
    rexx:=rex_starts[t*4+0]
    rexy:=rex_starts[t*4+1]
    rexxd:=rex_starts[t*4+2]
    rexyd:=rex_starts[t*4+3]
    rexmc:=0
    rexac:=REX_LIES_IN_WAIT
    rexwt:=1
    lastsx:=16
    lastsy:=16

pub handle_trex | t,x,y,c

  if rexwt==1
    return
    
  rexac:=REX_LIES_IN_WAIT
  c:=0
  if rexy==mapy
    rexac:=FOOTSTEPS_APPROACHING
    t:=0
    repeat c from rexx to mapx
      if getmap(c,rexy)<>"0"
        t:=1
    if t==0
      rexac:=REX_HAS_SEEN_YOU
      lastsx:=mapx
      lastsy:=mapy
      rexyd:=0
      rexxd:=1
      if rexx>mapx
        rexxd:=-1

  if rexx==mapx
    rexac:=FOOTSTEPS_APPROACHING
    t:=0
    repeat c from rexy to mapy
      if getmap(rexx,c)<>"0"
        t:=1
    if t==0
      rexac:=REX_HAS_SEEN_YOU
      lastsx:=mapx
      lastsy:=mapy
      rexxd:=0
      rexyd:=1
      if rexy>mapy
        rexyd:=-1

  if( ((||(rexx-mapx))==(||mapxr)) and ((||(rexy-mapy))==(||mapyr)) )
    rexac:=RUN_HES_BESIDE_YOU
  if( ((mapx-mapxd)==rexx) and ((mapy-mapyd)==rexy) )
    rexac:=RUN_HES_BEHIND_YOU

  if rexac==REX_LIES_IN_WAIT
    if rexx==lastsx or rexy==lastsy
      rexac:=HE_IS_HUNTING_FOR_YOU
    if ((||(rexx-mapx))<4) or ((||(rexy-mapy))<4)
      if ((||(rexx-mapx))<8) and ((||(rexy-mapy))<8)
        rexac:=FOOTSTEPS_APPROACHING
    if rexx==lastsx and rexy==lastsy
      lastsx:=16
      lastsy:=16
      if rexxd==0
        rexyd:=0
        if rexx<mapx
          rexxd:=1
        else
          rexxd:=-1
      else
        rexxd:=0
        if rexy<mapy
          rexyd:=1
        else
          rexyd:=-1

  if rexac<>REX_LIES_IN_WAIT
    rexmc++
    if rexmc==32
      rexmc:=0
      if getmap(rexx+rexxd,rexy+rexyd)=="0"
        rexx+=rexxd
        rexy+=rexyd
      else
        if rexxd==0
          rexyd:=0
          if rexx<mapx
            rexxd:=1
          else
            rexxd:=-1
        else
          rexxd:=0
          if rexy<mapy
            rexyd:=1
          else
            rexyd:=-1
        if getmap(rexx+rexxd,rexy+rexyd)<>"0"
          rexxd:=-rexxd
          rexyd:=-rexyd
          if getmap(rexx+rexxd,rexy+rexyd)<>"0"
            rexxd:=rexyd
            rexyd:=-rexxd
            if getmap(rexx+rexxd,rexy+rexyd)<>"0"
              rexxd:=-rexxd
              rexyd:=-rexyd
      if (rexac==HE_IS_HUNTING_FOR_YOU) or (rexac==FOOTSTEPS_APPROACHING)
        if rexxd==0
          if rexx<mapx
            if getmap(rexx+1,rexy)=="0"
              rexxd:=1
              rexyd:=0
          if rexx>mapx
            if getmap(rexx-1,rexy)=="0"
              rexxd:=-1
              rexyd:=0
        elseif rexyd==0
          if rexy<mapy
            if getmap(rexx,rexy+1)=="0"
              rexyd:=1
              rexxd:=0
          if rexy>mapy
            if getmap(rexx,rexy-1)=="0"
              rexyd:=-1
              rexxd:=0
   
pub showwalls | t,x,y,c,r

  r:=0
  if rexmc>16
    r:=768

  maze[(rexy<<4)+rexx]:="2"
  if mapxd==0 and mapyd==1
    maze[(mapy<<4)+mapx]:=79
  if mapxd==0 and mapyd==-1
    maze[(mapy<<4)+mapx]:=58
  if mapxd==1 and mapyd==0
    maze[(mapy<<4)+mapx]:=38
  if mapxd==-1 and mapyd==0
    maze[(mapy<<4)+mapx]:=39

  repeat y from 0 to 23
    bytemove(@myscr+y<<5,@walls+y<<5,25)

  c:=getmap(mapx+(mapxd*6),mapy+(mapyd*6))
  if c&1
    wallstrip(12,30, 1,0)
  if (getmap(mapx+(mapxd*5)-mapxr,mapy+(mapyd*5)-mapyr)&1)==0
    wallstrip(11,30,1,0)                                
  if (getmap(mapx+(mapxd*5)+mapxr,mapy+(mapyd*5)+mapyr)&1)==0
    wallstrip(13,30,1,0)

  c:=getmap(mapx+(mapxd*5),mapy+(mapyd*5))
  if c&1
    wallstrip(11,29, 3,0)
  if c=="2"
    showrex(@trexs+(0*768))
  if (getmap(mapx+(mapxd*4)-mapxr,mapy+(mapyd*4)-mapyr)&1)==0
    wallstrip(10,29,1,0)
  if (getmap(mapx+(mapxd*4)+mapxr,mapy+(mapyd*4)+mapyr)&1)==0
    wallstrip(14,29,1,0)

  c:=getmap(mapx+(mapxd*4),mapy+(mapyd*4))
  if c=="1"
    wallstrip(10,28, 5,0)
  if c=="2"
    showrex(@trexs+(1*768)+r)
  if c=="3"
    exitwall(10,5)
  if (getmap(mapx+(mapxd*3)-mapxr,mapy+(mapyd*3)-mapyr)&1)==0
    wallstrip( 8,28,2,0)
  if (getmap(mapx+(mapxd*3)+mapxr,mapy+(mapyd*3)+mapyr)&1)==0
    wallstrip(15,28,2,0)

  c:=getmap(mapx+(mapxd*3),mapy+(mapyd*3))
  if c=="1"
    wallstrip( 8,27, 9,0)
  if c=="2"
    showrex(@trexs+(3*768)+r)
  if c=="3"
    exitwall(8,9)
  if (getmap(mapx+(mapxd*2)-mapxr,mapy+(mapyd*2)-mapyr)&1)==0
    wallstrip(5,27,3,0)
  if (getmap(mapx+(mapxd*2)+mapxr,mapy+(mapyd*2)+mapyr)&1)==0
    wallstrip(17,27,3,0)

  c:=getmap(mapx+(mapxd*2),mapy+(mapyd*2))
  if c=="1"
    wallstrip( 5,26,15,0)
  if c=="2"
    showrex(@trexs+(5*768)+r)
  if c=="3"
    exitwall(5,15)
  if (getmap(mapx+(mapxd*1)-mapxr,mapy+(mapyd*1)-mapyr)&1)==0
    wallstrip(1,26,4,0)
  if (getmap(mapx+(mapxd*1)+mapxr,mapy+(mapyd*1)+mapyr)&1)==0
    wallstrip(20,26,4,0)

  c:=getmap(mapx+(mapxd*1),mapy+(mapyd*1))
  if c=="1"
    wallstrip( 1,25,23,0)
  if c=="2"
    showrex(@trexs+(7*768)+r)
  if c=="3"
    exitwall( 1,23)
  if (getmap(mapx-mapxr,mapy-mapyr)&1)==0
    wallstrip(0,25,1,0)
  if (getmap(mapx+mapxr,mapy+mapyr)&1)==0
    wallstrip(24,25,1,0)

  if (frame&7)==0
    exitchars[0]:=exitchars[1]
    exitchars[1]:=exitchars[2]
    exitchars[2]:=exitchars[3]
    exitchars[3]:=exitchars[4]
    exitchars[4]:=exitchars[5]
    exitchars[5]:=exitchars[6]
    exitchars[6]:=exitchars[7]
    exitchars[7]:=exitchars[8]    
    exitchars[8]:=exitchars[9]    
    exitchars[9]:=exitchars[10]    
    exitchars[10]:=(?seed)    

'  repeat y from 0 to 15
'    repeat x from 0 to 15
'      myscr[y<<5+x]:=maze[y<<4+x]-"0"+28

  maze[(mapy<<4)+mapx]:="0"
  maze[(rexy<<4)+rexx]:="0"

pub exitwall(x,wx) | i,ex,ep,l,r
  ep:=@exitchars
  repeat i from 0 to ((wx-1)>>1)-1
    bytefill(@myscr+((x+i)*33),byte[ep][0],wx-(i<<1))
    bytefill((@myscr+(23<<5))-((x+i)*31),byte[ep][0],wx-(i<<1))
    l:=@myscr+((x+i)*33)
    r:=@myscr+24+((x+i)*31)
    repeat ex from 0 to ((wx-1)-(i<<1))-1
      byte[l+(ex<<5)]:=byte[ep][0]
      byte[r+(ex<<5)]:=byte[ep][0]
    ep++

pub wallstrip(x,wx,wd,ws) | s,d
  d:=@myscr+x
  s:=@walls+wx
  repeat wd
    repeat 24
      byte[d][0]:=byte[s][0]
      s+=32
      d+=32
    s-=24*32
    d-=24*32
    d++
    s+=ws

pub getmap(x,y)
  if x<0 or x>15 or y<0 or y>15
    return "1"
  return maze[(y<<4)+x]

pub showrex(p) | x,y,s
  s:=@myscr
  repeat y from 0 to 23
    repeat x from 0 to 23
      if byte[p][0]<>$2d
        byte[s][0]:=byte[p][0]
      s++
      p++
    s+=8
    p+=8
      
pub scrolltext(pt) | i,sp
  sp:=25
  bytemove(@myscr,@clown1,768)
  repeat i from 0 to 21
    bytefill(@myscr+i*32+11,0,21)
  repeat while byte[pt][21]<>"2"
    repeat i from 0 to 20
      bytemove(@myscr+i*32+11,@myscr+32+i*32+11,21)
    bytefill(@myscr+21*32+11,0,21)
    sp:=WaitKey(sp)
    repeat i from 0 to 20
      bytemove(@myscr+i*32+11,@myscr+32+i*32+11,21)
    bytefill(@myscr+21*32+11,0,21)
    pchars(pt,11,21,0,21)
    pt+=22
    sp:=WaitKey(sp)
    if byte[pt][21]=="1"
      i:=0
      repeat while i==0
        wait(1)
        joy:=Read_Gamepad
        if key.keystate("i")
          pt:=@controls_message
          sp:=25
          i:=1          
        if key.keystate($CB)
          repeat 6
            repeat i from 0 to 20
              bytemove(@myscr+i*32+11,@myscr+32+i*32+11,21)
            bytefill(@myscr+i*32+11,0,21)
            wait(1*25)
          bytemove(@myscr,@clown2,768)
          repeat i from 0 to 21
            bytefill(@myscr+i*32+11,0,21)
          longmove(@tvscr,@myscr,768/4)
          return 2
        if joy & NES_A
          bytemove(@myscr,@clown2,768)
          repeat i from 0 to 21
            bytefill(@myscr+i*32+11,0,21)
          i:=1
    if byte[pt][21]=="3"
      pt:=@mists_message
  longmove(@tvscr,@myscr,768/4)
  return 1             

PUB Read_Gamepad : bits        |  i

' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5)
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding

' step 1: set I/Os
  DIRA [3] := 1 ' output
  DIRA [4] := 1 ' output
  DIRA [5] := 0 ' input
  DIRA [6] := 0 ' input

  OUTA [3] := 0 ' JOY_CLK = 0

  OUTA [4] := 0 ' JOY_SH/LDn = 0
  OUTA [4] := 1 ' JOY_SH/LDn = 1
  OUTA [4] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out
' first bit is ready
  bits := 0

  bits := INA[5] | (INA[6] << 8)

' step 7: read next 7 bits
  repeat i from 0 to 6
    OUTA [3] := 1 ' JOY_CLK = 1
    OUTA [3] := 0 ' JOY_CLK = 0
    bits := (bits<<1) + ( INA[5] | (INA[6] << 8) )

' invert bits to make positive logic
  bits := (!bits & $FFFF)

  if bits&$ff==$ff
    bits:=bits&$ff00
  if bits&$ff00==$ff00
    bits:=bits&$ff

' Keyboard (mapped onto NES buttons)
  if(key.keystate($C2) or key.keystate("7") )       'Up Arrow
    bits|=NES_UP
  if(key.keystate($C3) or key.keystate("6") )       'Down Arrow
    bits|=NES_DOWN
  if(key.keystate($C0) or key.keystate("5") )       'Left Arrow
    bits|=NES_LEFT
  if(key.keystate($C1) or key.keystate("8") )       'Right Arrow
    bits|=NES_RIGHT
  if(key.keystate($0D))       'Enter
    bits|=NES_START
  if(key.keystate(" "))       'Space
    bits|=NES_A

  if key.keystate($d8)
    tvparams[3]:=1
    tvparams[6]:=12
  if key.keystate($d9)
    tvparams[3]:=0
    tvparams[6]:=10

PUB printat(p,x,y,clr)
  txtx:=x
  txty:=y
  txtcol:=clr
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++    

PUB print(p)
  repeat while byte[p][0]<>0
    print_char(byte[p][0])
    p++
  txtx:=0
  if txty<23
    txty++    

pub pchars(p,x,y,clr,count)
  txtx:=x
  txty:=y
  txtcol:=clr
  repeat count
    print_char(byte[p][0])
    p++

PUB print_char(p) | y, s,d
  if p=>"A" and p=<"Z"
    p-="A"-38
  elseif p=>"a" and p=<"z"
    p-="a"-(38+128)
  elseif p=>"0" and p=<"9"
    p-="0"-28
  elseif p==" "
    p:=0
  elseif p=="'"
    p:=11
  elseif p==":"
    p:=14
  elseif p=="?"
    p:=15
  elseif p=="="
    p:=20
  elseif p=="+"
    p:=21
  elseif p=="-"
    p:=22
  elseif p==","
    p:=26
  elseif p=="."
    p:=27
  myscr[txty<<5+txtx]:=p+txtcol
  txtx++
  if txtx>31
    txtx:=0
    if txty<23
      txty++

PUB Wait(aTime) | target
  seed:=(?seed)
  frame++
  repeat aTime
    byte[@tvparams]:=0
    repeat until byte[@tvparams]>0
    longmove(@tvscr,@myscr,768/4)
      
PUB WaitKey(aTime) | target
  seed:=(?seed)
  frame++
  repeat aTime
    byte[@tvparams]:=0
    repeat until byte[@tvparams]>0
    longmove(@tvscr,@myscr,768/4)
    ojoy:=joy
    joy:=Read_Gamepad
    if ((joy & NES_A) and ((ojoy&NES_A)==0)) or ((joy & NES_START) and ((ojoy&NES_START)==0))
      return 1
  return aTime

pub addscore(addstring) | x,c,el
  c:=0
  repeat x from 0 to 3
    scoretxt[3-x]+=(byte[addstring][3-x]-"0")+c
    c:=0
    if scoretxt[3-x]>"9"
      scoretxt[3-x]-=10
      c:=1 

pub pscore(x,y) | tx,ty
  bytefill(@myscr+y<<5+x,0,4)
  tx:=0
  repeat ty from 0 to 2
    if scoretxt[ty]=="0"
      tx:=ty+1
    else
      ty:=2 
  pchars(@scoretxt[tx],x+tx,y,0,4-tx)
        
dat

hextab        byte      "0123456789ABCDEF"

VSync         long
tvparams      long      0               'status
              long      1               'enable
              long      tv_pins         'pins
              long      mode            'mode
              long      x_tiles         'hc
              long      y_tiles         'vc
              long      my_hx           'hx
              long      1               'vx
              long      0               'ho
              long      0               'vo
              long      50_000_000'_xinfreq<<4  'broadcast
              long      0               'auralcog
tvscrptr      long      0 '@screen+$10
              long      @invertedbytes+$10
              
invertedbytes file      "invtab.bin"

bordercolour  long      $07

trexs         file      "trex512.Z81"
              file      "trex41.Z81"
              file      "trex42.Z81"
              file      "trex31.Z81"
              file      "trex32.Z81"
              file      "trex21.Z81"
              file      "trex22.Z81"
              file      "trex11.Z81"
              file      "trex12.Z81"
eaten1        file      "eaten1.Z81"
eaten2        file      "eaten2.Z81"
clown1        file      "clown1.Z81"
clown2        file      "clown2.Z81"
walls         file      "walls.Z81"

roll_up_message         byte
              byte      "  ROLL UP,ROLL UP,   0"
              byte      "SEE THE AMAZING      0"
              byte      "TYRANNOSAURUS REX    0"
              byte      "KING OF THE DINOSAURS0"
              byte      "IN HIS LAIR.         0"
              byte      "PERFECTLY PRESERVED  0"
              byte      "IN SILICON SINCE     0"
              byte      "PREHISTORIC TIMES,HE 0"
              byte      "IS BROUGHT TO YOU FOR0"
              byte      "YOUR ENTERTAINMENT   0"
              byte      "AND EXHILARATION.    0"
              byte      "  IF YOU DARE TO     0"
              byte      "ENTER HIS LAIR,YOU DO0"
              byte      "SO AT YOUR OWN RISK. 0"
              byte      "THE MANAGEMENT ACCEPT0"
              byte      "NO RESPONSIBILITY FOR0"
              byte      "THE HEALTH AND SAFETY0"
              byte      "OF THE ADVENTURER WHO0"
              byte      "ENTERS HIS REALM.THE 0"
              byte      "MANAGEMENT ADVISE    0"
              byte      "THAT THIS IS NOT A   0"
              byte      "GAME FOR THOSE OF A  0"
              byte      "NERVOUS DISPOSITION. 0"
              byte      "  IF YOU ARE IN ANY  0"
              byte      "DOUBT,THEN PRESS esc 0"
              byte      "OTHERWISE PRESS i FOR0"
              byte      "INSTRUCTIONS, OR     0"
              byte      "space TO START.      0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     1"
                        
mists_message byte      "                     0"
              byte      "                     0"
              byte      "  THE MISTS OF TIME  0"
              byte      "WILL PASS OVER YOU   0"
              byte      "FOR ABOUT 30 SECONDS 0"
              byte      "WHILE TRANSPORTING   0"
              byte      "YOU TO THE LAIR OF   0"
              byte      "TYRANNOSAURUS REX.   0"
              byte      "  BEST OF LUCK.....  0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     2"

controls_message
              byte      "  THE ONLY CONTROLS  0"
              byte      "YOU REQUIRE ARE:-    0"
              byte      "  5....TURN LEFT     0"
              byte      "  7....MOVE FORWARD  0"
              byte      "  8....TURN RIGHT    0"
              byte      "FURTHER INFORMATION  0"
              byte      "IS PROVIDED DURING   0"
              byte      "THE ENCOUNTER.       0"
              byte      "  FOR EACH MOVE      0"
              byte      "SCORING IS AS FOLLOWS0"
              byte      "  5 PTS-WHILE HE IS  0"
              byte      "        TRACKING YOU.0"
              byte      "200 PTS-IF YOU ESCAPE0"
              byte      "        HIS LAIR.    0"
              byte      "  SINCE REX IS ALWAYS0"
              byte      "TRYING TO MOVE       0"
              byte      "TOWARDS HIS PREY, A  0"
              byte      "SKILFUL ADVENTURER   0"
              byte      "CAN CONTROL THE      0"
              byte      "MONSTERS MOVEMENTS TO0"
              byte      "IMPROVE HIS SCORE.   0"
              byte      "THE ESCAPE ROUTE,    0"
              byte      "WHICH IS AT THE END  0"
              byte      "OF A CUL-DE-SAC,IS   0"
              byte      "VISIBLE UP TO 5 MOVES0"
              byte      "AWAY.                0"
              byte      "  THE GAME ENDS WHEN 0"
              byte      "HE CATCHES YOU.IF YOU0"
              byte      "ESCAPE A NEW MAZE IS 0"
              byte      "GENERATED AND YOUR   0"
              byte      "PREVIOUS SCORE       0"
              byte      "CARRIED FORWARD.     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     0"
              byte      "                     3"

rex_texts     byte      "                      "
              byte      "   REX LIES IN WAIT   "
              byte      " HE IS HUNTING FOR YOU"
              byte      " FOOTSTEPS APPROACHING"
              byte      " run HE IS BEHIND YOU "
              byte      " run HE IS BESIDE YOU "
              byte      "   REX HAS SEEN YOU   "

loading_texts byte      "LOAD l        "
              byte      "LOAD 'l       "
              byte      "LOAD '3l      "
              byte      "LOAD '3Dl     "
              byte      "LOAD '3DMl    "
              byte      "LOAD '3DMAl   "
              byte      "LOAD '3DMAZl  "
              byte      "LOAD '3DMAZEl "
              byte      "LOAD '3DMAZE'l"

exitchars     byte      "ABCDEFGHIJ  "

cleared_text
              byte      "       "              
              byte      "  YOU  "
              byte      "  HAVE "
              byte      " ELUDED"              
              byte      "  HIM  "              
              byte      "  AND  "              
              byte      " SCORED"              
              byte      "       "              
              byte      " POINTS"              
              byte      "       "              
              byte      " REX IS"              
              byte      "  VERY "              
              byte      " ANGRY."              
              byte      "       "              
              byte      " YOU,LL"              
              byte      "  NEED "              
              byte      "  MORE "              
              byte      "  LUCK "              
              byte      "  THIS "              
              byte      "  TIME."
              byte      "       "              
              byte      "       "              
              byte      "       "              
              byte      "       "              

scoretext     byte      "SCORE "                            
scoretxt      byte      "0000"
add5txt       byte      "0005"
add200txt     byte      "0200"

maze          byte      "0000000000000000"
              byte      "0111110111111010"
              byte      "0100000010000010"
              byte      "0101101110101110"
              byte      "0001000000100010"
              byte      "0111011111101010"
              byte      "0000000000001000"
              byte      "0111111110111010"
              byte      "0100010000001010"
              byte      "0101010111101010"
              byte      "0101010100001010"
              byte      "0101310101100000"
              byte      "0101110101111010"
              byte      "0100000000000010"
              byte      "0111111111011110"
              byte      "0000000000000000"

rex_starts    long      10, 2,-1, 0
              long       5, 4, 0,-1
              long       8, 6,-1, 0
              long       4,10, 0,-1     
        